# =============================================================================== #
# xxx <>>> ES/PYTHON IMPORTS xxxxxxxxxx #
import es, playerlib
import psyco
psyco.full()
# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #

# xxxxxxxxxx # SAM IMPORTS # xxxxxxxxxx #
func    = es.import_addon('sam/functions')
admins  = es.import_addon('sam/core/admins')
monitor = es.import_addon('sam/core/monitor')
mute    = es.import_addon('sam/core/pcontrol/mute')
# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #

# x # VARIABLES/DICTIONARIES/LISTS # xx #
temp    = {'active':True,'showgroup':True}
teams   = {1:'#spec',2:'#t',3:'#ct'}
alltalk = es.ServerVar('sv_alltalk')
# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #

# =============================================================================== #
# === <<<> LOAD <>>> ============================================================ #
# =============================================================================== #
def load():

	# CMDS
	func.ServerCMD('sam_adminschat_active', activeCMD)
	func.ServerCMD('sam_adminschat_showgroup', groupCMD)

	# CFG
	lib = {'sam_adminschat_active':{'value':1,'description':'Active Chat: If 0 Admins need to start talking with # to talk as an Admin, if 1 they dont.'},
		   'sam_adminschat_showgroup':{'value':1,'description':'Show Groups: Shows the Group of the Admin, if he is in one, else he will talk as an Admin.'}}
	monitor.cfg('adminschat', lib)

	# FILTERS
	es.addons.registerSayFilter(chatFilter)

# =============================================================================== #
# === <<<> UNLOAD <>>> ========================================================== #
# =============================================================================== #
def unload():

	# CMDS
	func.unServerCMD('sam_adminschat_active')
	func.unServerCMD('sam_adminschat_showgroup')

	# FILTERS
	es.addons.unregisterSayFilter(chatFilter)

# =============================================================================== #
# === <<<> FUNCTIONS <>>> ======================================================= #
# =============================================================================== #
def chatFilter(ID, TEXT, TEAM):
	text   = TEXT.strip('"')
	R      = (ID, TEXT, TEAM)
	if admins.can(ID,'Admins Chat',False):
		player = playerlib.getPlayer(ID)
		admin  = admins.db['admins'][player.steamid]
		groups = admins.db['groups']
		if not ID in func.cloud['filters']:
			cmd = text.split()
			if not es.exists('saycommand', cmd[0]):
				if text.startswith('###'):
					func.centermsg('#all', text.strip('###').strip(' '))
					R = (0,0,0)
				elif text.startswith('##'):
					func.say('#all', '#grey[GLOBAL] : #white%s' % text.strip('##').strip(' '))
					R = (0,0,0)
				elif text.startswith('#') or temp['active']:
					if not TEAM:
						if not text.startswith('#'):
							if not admin['group'] == 'NO_GROUP': group = admin['group']
							else: group = False
							if group and temp['showgroup']:
								color = groups[group]['color']
								if player.isdead:
									if player.teamid > 1: func.say('#all', '*DEAD* #grey[%s%s#grey] %s%s #default: %s' % (color,group.upper(),teams[player.teamid],player.name,str(text)))
									else: func.say('#all', '*SPEC* #grey[%s%s#grey] %s%s #default: %s' % (color,group.upper(),teams[player.teamid],player.name,str(text)))
								else: func.say('#all', '#grey[%s%s#grey] %s%s #default: %s' % (color,group.upper(),teams[player.teamid],player.name,str(text)))
							elif player.isdead:
								if int(alltalk):
									if player.teamid > 1: func.say('#all', '*DEAD* #grey[#cyanADMIN#grey] %s%s #default: %s' % (teams[player.teamid],player.name,text))
									else: func.say('#all', '*SPEC* #grey[#cyanADMIN#grey] %s%s #default: %s' % (teams[player.teamid],player.name,text))
								else:
									if player.teamid != 1: func.say('#dead', '*DEAD* #grey[#cyanADMIN#grey] %s%s #default: %s' % (teams[player.teamid],player.name,text))
									else: func.say('#dead', '*SPEC* #grey[#cyanADMIN#grey] %s%s #default: %s' % (teams[player.teamid],player.name,text))
							else: func.say('#all', '#grey[#cyanADMIN#grey] %s%s #default: %s' % (teams[player.teamid],player.name,text))
						else: func.say('#all', '#grey[#cyanADMIN#grey] %s%s #default: %s' % (teams[player.teamid],player.name,text.strip('#').strip(' ')))
						R = (0, 0, 0)
					else:
						if text.startswith('#'):
							for ply in es.getUseridList():
								if admins.can(ply,'Admins Chat',False): func.say(ply, '#green[ADMINS ONLY] #grey%s#green: #lightgreen%s' % (es.getplayername(ID),text.strip('#').strip(' ')))
							R = (0, 0, 0)
	else:
		if text.startswith('#'):
			for ply in es.getUseridList():
				if admins.isAdmin(es.getplayername(ply)) and ply != ID: func.say(ply, '#green%s to Admins #green: #lightgreen%s' % (es.getplayername(ID),text.strip('#').strip(' ')))
			func.say(ID, '#greenYou to Admins #green: #lightgreen%s' % (text.strip('#').strip(' ')))
			R = (0, 0, 0)
	return R


# =============================================================================== #
# === <<<> CMD BLOCKS <>>> ====================================================== #
# =============================================================================== #
def activeCMD(args):
	if args:
		try:
			args = int(' '.join(args))
			if args in (1,0): temp['active'] = bool(args)
		except: pass

# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #
def groupCMD(args):
	if args:
		try:
			args = int(' '.join(args))
			if args in (1,0): temp['showgroup'] = bool(args)
		except: pass

# =============================================================================== #