# =============================================================================== #
# xxx <>>> ES/PYTHON IMPORTS xxxxxxxxxx #
import es, os
from configobj import ConfigObj
import psyco
psyco.full()
# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #

# xxxxxxxxxx # SAM IMPORTS # xxxxxxxxxx #
func   = es.import_addon('sam/functions')
core   = es.import_addon('sam/core')
admins = es.import_addon('sam/core/admins')
# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #

# x # VARIABLES/DICTIONARIES/LISTS # xx #
addons = []
CACHE  = {}
msgs   = []
# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #

# =============================================================================== #
# === <<<> LOAD <>>> ============================================================ #
# =============================================================================== #
def load():

	# LOAD ADDONS
	es.load('sam/addons')
	for x in getAddons():
		if int(get(x, 'state')): es.load('sam/addons/%s' % x)

# =============================================================================== #
# === <<<> UNLOAD <>>> ========================================================== #
# =============================================================================== #
def unload():

	# UNLOAD ADDONS
	for x in getAddons():
		if int(get(x, 'state')): es.unload('sam/addons/%s' % x)
	es.unload('sam/addons')

	# POPUPS
	func.popupDelete('ADDONS_LIST')
	func.popupDelete('ADDONS_MONITOR')

# =============================================================================== #
# === <<<> MAIN BLOCKS <>>> ===================================================== #
# =============================================================================== #
def page(ID, SEND=True, PAGE=False):
	if admins.can(ID, 'Addons Monitor'):
		popup = func.easymenu(('ADDONS_LIST', monitor),'HOME')
		popup.settitle(func.header(func.langCommon('TITLE_MONITOR')))
		for x in sorted(getAddons()):
			addon = get(x)
			if int(addon['state']): popup.addoption(x, '%s - (%s)' % (addon['name'],func.langCommon('ON').upper()))
			else: popup.addoption(x, '%s - (%s)' % (addon['name'],func.langCommon('OFF').upper()))
		if PAGE: popup.sendPage(ID, PAGE)
		elif SEND: popup.send(ID)
	else: core.home(ID)

# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #
def monitor(ID, ADDON , POPUP):
	addon     = get(ADDON)
	CACHE[ID] = addon['basename']
	popup     = func.simplemenu('ADDONS_MONITOR','ADDONS_LIST',False)
	popup.addline(func.header(func.langCommon('TITLE_MONITOR')))
	popup.addline(func.line)
	popup.addline('%s: %s' % (func.langCommon('NAME'),addon['name']))
	popup.addline('%s: %s' % (func.langCommon('VERSION'),addon['version']))
	popup.addline('%s:\n- %s' % (func.langCommon('DESCRIPTION'),addon['description']))
	if addon['version'].endswith('.b'):
		popup.addline(func.line)
		popup.addline('%s:' % func.langCommon('WARNING'))
		popup.addline(func.langCore('ADDON_IN_BETA'))
	popup.addline(func.line)
	if not int(addon['state']): line = '->1: %s: %s : [ %s ]' % (func.langCommon('STATUS'),func.langCommon('ON'),func.langCommon('OFF'))
	else: line = '->1: %s: [ %s ] : %s' % (func.langCommon('STATUS'),func.langCommon('ON'),func.langCommon('OFF'))
	popup.addline(line.upper())
	popup.addline(func.line)
	popup.addline('->0. %s' % func.langCommon('CANCEL'))
	popup.menuselect = monitor_SELECT
	popup.send(ID)

# ------------------------------------------------------------------------------- #
def monitor_SELECT(ID, CHOICE, POPUP):
	if CHOICE == 1:
		addon = get(CACHE[ID])
		if int(addon['state']) > 0: 
			es.unload('sam/addons/%s' % addon['basename'])
			addon['state'] = 0
		else: 
			es.load('sam/addons/%s' % addon['basename'])
			addon['state'] = 1
		addon.write()
		core.home(ID, False)
		monitor(ID, addon['basename'], None)
	if CHOICE == 10:
		l = getAddons()
		page(ID, False, func.sendPage(l.index(CACHE[ID])))

# =============================================================================== #
# === <<<> FUNCTIONS <>>> ======================================================= #
# =============================================================================== #
def getAddons():
	dir = func.sampath+'/addons/'
	return [x for x in os.listdir(dir) if os.path.isdir(dir + x) == True and not x in ('deaktalk','res','clock')]

# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #
def get(ADDON, KEY=False):
	addon = ConfigObj(func.sampath + '/addons/%s/info.ini' % ADDON)
	if KEY: return addon[KEY]
	else:   return addon

# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #
def addmsg(MSG):
	adverts = get('adverts')
	if int(adverts['state']):
		if not MSG in msgs: msgs.append(MSG)

# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #
def removemsg(MSG):
	adverts = get('adverts')
	if int(adverts['state']):
		if MSG in msgs: msgs.remove(MSG)

# =============================================================================== #
# === <<<> ADDONS CONFIGURATION SYSTEM <>>> ===================================== #
# =============================================================================== #
def cfg(ADDON, TOKENS):
	path = func.addonscfg + ADDON + '.cfg'
	if not os.path.isfile(path):
		cfg = open(path,'w')
		cfg.write('// %s\n' % ('-' * 50))
		cfg.write('//  Source Admin Menu | %s Configuration File\n' % get(ADDON,'name'))
		cfg.write('// %s\n' % ('-' * 50))
		cfg.write('//  * Do not restart the server after changing the commands!\n')
		cfg.write('//  * Any changes will take effect within 10 seconds after you save this file.\n')
		cfg.write('// %s\n \n' % ('-' * 50))
		for cmd in TOKENS:
			cfg.write('// %s\n' % TOKENS[cmd]['description'])
			cfg.write('//\n')
			cfg.write('// Default: %s\n' % TOKENS[cmd]['value'])
			cfg.write('%s %s\n \n' % (cmd,TOKENS[cmd]['value']))
		cfg.close()

# =============================================================================== #