# =============================================================================== #
# xxx <>>> ES/PYTHON IMPORTS xxxxxxxxxx #
from __future__ import with_statement
import es, playerlib, gamethread, time
import psyco
psyco.full()
# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #

# xxxxxxxxxx # SAM IMPORTS # xxxxxxxxxx #
func     = es.import_addon('sam/functions')
core     = es.import_addon('sam/core')
admins   = es.import_addon('sam/core/admins')
pcontrol = es.import_addon('sam/core/pcontrol')
# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #

# x # VARIABLES/DICTIONARIES/LISTS # xx #
dbname = 'sam_bans.db'
data   = func.getDB(dbname)
tag    = '#greenBAN'
TEMP   = {}
# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #

# xxxxxxxxxxx # BAN LEVELS # xxxxxxxxxx #
level = {1:{'5m':300,'30m':1800,'1h':3600,'3h':10800,'1d':86400},
		 2:{'3d':259200,'1w':604800,'1m':2592000,'1':31536000}}
sort  = ('perm','5m','30m','1h','3h','1d','3d','1w','1mo','1y')
# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #

# =============================================================================== #
# === <<<> LOAD <>>> ============================================================ #
# =============================================================================== #
def load():

	# CMDS
	func.SayCMD('!ban', banCMD)
	func.SayCMD('!sam_ban', banCMD)
	func.SayCMD('!unban', unbanCMD)
	func.SayCMD('!sam_unban', unbanCMD)

# =============================================================================== #
# === <<<> UNLOAD <>>> ========================================================== #
# =============================================================================== #
def unload():

	# CMDS
	func.unSayCMD('!ban')
	func.unSayCMD('!sam_ban')
	func.unSayCMD('!unban')
	func.unSayCMD('!sam_unban')

	# SAVE DATABASE
	func.saveDB(dbname, data)

	# POPUPS
	func.popupDelete('BAN_PLAYERS_LIST')
	func.popupDelete('BAN_GET_TIME')
	func.popupDelete('BAN_GET_REASON')
	func.popupDelete('UNBAN_BANS_LIST')
	func.popupDelete('BAN_PROFILE')

# =============================================================================== #
# === <<<> BAN BLOCK <>>> ======================================================= #
# =============================================================================== #
def banPage(ID):
	popup = func.easymenu(('BAN_PLAYERS_LIST', ban_get_time), 'PCONTROL_MAIN')
	popup.settitle(func.header(func.langPcontrol('BAN')))
	for x in playerlib.getPlayerList('#human'):
		if admins.isAdmin(x.steamid):
			if admins.db['admins'][x.steamid]['Super Admin']: popup.addoption(x, '%s (Super Admin)' % x.name)
			else: popup.addoption(x, '%s (Admin)' % x.name)
		else: popup.addoption(x, x.name)
	popup.send(ID)

# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #
def ban_get_time(ID, TARGET, POPUP):
	if admins.immunity(playerlib.getPlayer(ID),TARGET):
		TEMP[TARGET.STEAMID] = {'name':TARGET.name,'admin':es.getplayername(ID)}
		popup = func.easymenu(('BAN_GET_TIME', ban_get_reason),'BAN_PLAYERS_LIST')
		popup.settitle(func.header(func.langPcontrol('FOR_HOW_LONG')))
		i = admins.can(ID,'Ban')
		for x in sort:
			if i == 1:
				if x in level[1]: popup.addoption([x,TARGET], x.replace(x,func.langPcontrol(x.upper())))
			elif i == 2: popup.addoption([x,TARGET], x.replace(x,func.langPcontrol(x.upper())))
		popup.send(ID)
	else:
		pcontrol.page(ID, False)
		banPage(ID)

# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #
def ban_get_reason(ID, TOKENS, POPUP):
	target = TOKENS[1]
	length = TOKENS[0]
	TEMP[target.steamid]['length'] = length.upper()
	if length == 'perm':   TEMP[target.steamid]['banid'] = 'perm'
	if length in level[1]: TEMP[target.steamid]['banid'] = int(time.time()) + level[1][length]
	if length in level[2]: TEMP[target.steamid]['banid'] = int(time.time()) + level[2][length]
	if len(getReasons()) > 0:
		popup = func.easymenu(('BAN_GET_REASON', ban),'BAN_GET_TIME')
		popup.settitle(func.header(func.langPcontrol('FOR_WHAT_REASON')))
		for x in getReasons(): popup.addoption([x,target], x)
		popup.send(ID)
	else: ban(ID, ['No reason given',target], None)

# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #
def ban(ID, TOKENS, POPUP, MSG=True, SEND=True):
	target = TOKENS[1]
	TEMP[target.steamid]['reason'] = TOKENS[0]
	data[target.steamid] = TEMP[target.steamid].copy()
	if es.exists('userid',target):
		target.kick(reason=func.langPcontrol('BAN_REASON', data[target.steamid].copy()))
		if MSG: gamethread.delayed(.1, func.tell, ('#all', func.langPcontrol('TARGET_BANNED', data[target.steamid].copy()), tag))
	if SEND: banPage(ID)
	del TEMP[target.steamid]

# =============================================================================== #
# === <<<> UNBAN BLOCK <>>> ===================================================== #
# =============================================================================== #
def unbanPage(ID, SEND=True):
	banlist = [x for x in data if isBanned(x)]
	if len(banlist) > 0:
		popup = func.easymenu(('UNBAN_BANS_LIST', ban_profile),'PCONTROL_MAIN')
		popup.settitle(func.header(func.langPcontrol('UNBAN')))
		for x in banlist:
			target = data[x].copy()
			popup.addoption(x, '%s [%s]' % (target['name'],func.langPcontrol(target['length'])))
		popup.send(ID)
	else:
		if SEND: pcontrol.page(ID)
		func.hudhint(ID, func.langPcontrol('NO_BANNED_PLAYERS'), 'UNBAN')

# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #
def ban_profile(ID, TARGET, POPUP='UNBAN_BANS_LIST'):
	target   = data[TARGET].copy()
	TEMP[ID] = TARGET
	popup = func.simplemenu('BAN_PROFILE',POPUP)
	popup.addline(func.header(func.langPcontrol('UNBAN')))
	popup.addline(func.line)
	popup.addline(' # %s: %s' % (func.langCommon('NAME').upper(),target['name']))
	popup.addline(' # ID: %s' % (TARGET))
	popup.addline(' # %s: %s' % (func.langCommon('LENGTH').upper(), func.langPcontrol('PERM')))
	popup.addline(' # ADMIN: %s' % target['admin'])
	popup.addline(' # %s: %s' % (func.langCommon('REASON').upper(), target['reason']))
	popup.addline(' \n%s' % func.langPcontrol('CONFIRM_UNBAN'))
	popup.addline('->1. %s' % func.langCommon('YES'))
	popup.addline('->2. %s' % func.langCommon('NO'))
	popup.addline(func.line)
	popup.addline('0. %s' % func.langCommon('CANCEL'))
	popup.menuselect = unbanChoice
	popup.send(ID)

# ------------------------------------------------------------------------------- #
def unbanChoice(ID, CHOICE, POPUP):
	if CHOICE == 1:
		func.hudhint(ID, func.langPcontrol('TARGET_UNBANNED', data[TEMP[ID]].copy()), 'UNBAN')
		del data[TEMP[ID]]
		unbanPage(ID)
	elif CHOICE == 2: unbanPage(ID)
	elif not CHOICE == 10: ban_profile(ID, TEMP[ID], None)
	del TEMP[ID]

# =============================================================================== #
# === <<<> FUNCTIONS <>>> ======================================================= #
# =============================================================================== #
def getReasons():
	with open(func.reasonsfile) as f: return [line.strip('\n') for line in f.readlines() if not line.startswith('#') and not line.startswith(' ')]

# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #
def isBanned(TARGET, R=False):
	if TARGET in data:
		if data[TARGET]['banid'] == 'perm': R = True
		elif int(data[TARGET]['banid']) > int(time.time()): R = True
		else: del data[TARGET]
	return R

# =============================================================================== #
# === <<<> CMD BLOCKS <>>> ====================================================== #
# =============================================================================== #
def banCMD(ID, ARGS):
	if admins.isAdmin(es.getplayersteamid(ID)):
		if int(admins.can(ID,'Ban')) > 0:
			core.home(ID, False)
			pcontrol.page(ID, False)
			if ARGS:
				target = es.getuserid(ARGS[0])
				if es.exists('userid', target): ban_get_time(ID, playerlib.getPlayer(target), None)
				else: func.hudhint(ID, func.langPcontrol('TARGET_NOT_EXISTS',{'target':ARGS[0]}),'BAN')
			else: banPage(ID)

# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #
def unbanCMD(ID, ARGS):
	if admins.can(ID,'Unban'):
		target = ''.join(ARGS)
		if len(list(data)):
			core.home(ID, False)
			pcontrol.page(ID, False)
			if ARGS:
				if target.startswith('STEAM_') and target in data: ban_profile(ID, target, None)
				else:
					found = [x for x in data if target.lower() in data[x]['name'].lower()]
					if len(found) == 0: func.hudhint(ID, func.langPcontrol('NO_BANNED_PLAYERS_FOUND'), 'UNBAN')
					elif len(found) == 1: ban_profile(ID, found[0], 'PCONTROL_MAIN')
					elif len(found) > 1: func.hudhint(ID, func.langPcontrol('MULTI_BANNED_PLAYERS_FOUND'), 'UNBAN')
			else: unbanPage(ID)
		else: func.hudhint(ID, func.langPcontrol('NO_BANNED_PLAYERS'), 'UNBAN')

# =============================================================================== #
# === <<<> EVENTS <>>> ========================================================== #
# =============================================================================== #
def player_activate(EV):
	if isBanned(EV['es_steamid']):
		target = playerlib.getPlayer(EV['userid'])
		target.kick(reason=func.langPcontrol('BAN_REASON', data[target.steamid].copy()))

# =============================================================================== #